<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditOrderPassengerRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="中文姓名" prop="TourOrderPassenage.chineseName">
              <el-input
                class="input-item"
                v-model="formData.TourOrderPassenage.chineseName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="英文姓名" prop="TourOrderPassenage.englishName">
              <el-input
                class="input-item"
                v-model="formData.TourOrderPassenage.englishName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="国籍" prop="TourOrderPassenage.nationality">
              <el-input
                class="input-item"
                v-model="formData.TourOrderPassenage.nationality"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="生日" prop="TourOrderPassenage.birthday">
              <el-date-picker
                class="input-item"
                v-model="formData.TourOrderPassenage.birthday"
                type="date"
                placeholder=""
                :clearable="true"
                format="YYYY-MM-DD"
                value-format="YYYY-MM-DD"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="手机号码" prop="TourOrderPassenage.mobile">
              <el-input
                class="input-item"
                v-model="formData.TourOrderPassenage.mobile"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSaveClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditOrderPassenger',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode } from '@/common/utils';
import { TourOrderPassenageData } from '@/api/generated/tourOrderPassenageController';
import { TourOrderPassenageController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    orderId?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    orderId: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditOrderPassengerRef = ref();
// 表单数据定义
type FormEditOrderPassengerData = {
  TourOrderPassenage: TourOrderPassenageData;
};
// 表单数据
const formData = reactive<FormEditOrderPassengerData>({
  TourOrderPassenage: {
    // ID主键
    id: undefined,
    // 中文姓名
    chineseName: undefined,
    // 英文姓名
    englishName: undefined,
    // 国籍
    nationality: undefined,
    // 生日
    birthday: undefined,
    // 手机号码
    mobile: undefined,
    // 订单号信息
    orderId: undefined,
    // 创建用户
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新用户
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourOrderPassenage.chineseName': [
    {required: true, message: '请输入中文姓名', trigger: 'blur'}
  ],
  'TourOrderPassenage.mobile': [
    {required: true, message: '请输入手机号码', trigger: 'blur'}
  ],
  'TourOrderPassenage.birthday': [
    {required: true, message: '请输入生日', trigger: 'blur'}
  ],
  'TourOrderPassenage.nationality': [
    {required: true, message: '请输入国籍', trigger: 'blur'}
  ],
  'TourOrderPassenage.englishName': [
    {required: true, message: '请输入英文姓名', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourOrderPassenageData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourOrderPassenage = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourOrderPassenageController.view(params).then(res => {
      formData.TourOrderPassenage = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditOrderPassenger = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditOrderPassenger = () => {
  refreshFormEditOrderPassenger();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditOrderPassenger();
};
/**
 * 保存
 */
const onSaveClick = () => {
  formEditOrderPassengerRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let formData = {
        ...formData.TourOrderPassenage
      };
  props.dialog?.submit(formData);
      return;
    }
    console.log('props.orderId')
    console.log(props.orderId)
    let params: ANY_OBJECT = {
      tourOrderPassenageDto: {
        id: formData.TourOrderPassenage.id,
        chineseName: formData.TourOrderPassenage.chineseName,
        englishName: formData.TourOrderPassenage.englishName,
        nationality: formData.TourOrderPassenage.nationality,
        birthday: formData.TourOrderPassenage.birthday,
        mobile: formData.TourOrderPassenage.mobile,
        createUserId: formData.TourOrderPassenage.createUserId,
        createTime: formData.TourOrderPassenage.createTime,
        updateUserId: formData.TourOrderPassenage.updateUserId,
        updateTime: formData.TourOrderPassenage.updateTime,
        orderId: props.orderId,
      }
    };

    let httpCall = isEdit.value ? TourOrderPassenageController.update : TourOrderPassenageController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourOrderPassenageData().then(res => {
    if (isEdit.value) refreshFormEditOrderPassenger();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
